commit 092e98d94080ca253dc4ef6957d6efaeccb88df6
Author: Richard Biener <rguenther@suse.de>
Date:   Tue Oct 12 13:42:08 2021

    tree-optimization/102572 - fix gathers with invariant mask
    
    This fixes the vector def gathering for invariant masks which
    failed to pass in the desired vector type resulting in a non-mask
    type to be generate.
    
    2021-10-12  Richard Biener  <rguenther@suse.de>
    
            PR tree-optimization/102572
            * tree-vect-stmts.c (vect_build_gather_load_calls): When
            gathering the vectorized defs for the mask pass in the
            desired mask vector type so invariants will be handled
            correctly.
    
            * g++.dg/vect/pr102572.cc: New testcase.
    
    (cherry picked from commit 9f12a45ef147e563f099c24c293830727e8204cc)

diff --git a/gcc/testsuite/g++.dg/vect/pr102572.cc b/gcc/testsuite/g++.dg/vect/pr102572.cc
new file mode 100644
index 00000000000..0a713081537
--- /dev/null
+++ b/gcc/testsuite/g++.dg/vect/pr102572.cc
@@ -0,0 +1,14 @@
+// { dg-do compile }
+// { dg-additional-options "-O3" }
+// { dg-additional-options "-march=skylake-avx512" { target x86_64-*-* i?86-*-* } }
+
+int a, b, c, f;
+void g(bool h, int d[][5])
+{
+  for (short i = f; i; i += 1)
+    {
+      a = h && d[0][i];
+      for (int j = 0; j < 4; j += c)
+	b = 0;
+    }
+}
diff --git a/gcc/tree-vect-stmts.c b/gcc/tree-vect-stmts.c
index 2c86f06a57b..0d61b0f51d0 100644
--- a/gcc/tree-vect-stmts.c
+++ b/gcc/tree-vect-stmts.c
@@ -2731,7 +2731,7 @@ vect_build_gather_load_calls (vec_info *vinfo, stmt_vec_info stmt_info,
   if (mask)
     vect_get_vec_defs_for_operand (vinfo, stmt_info,
 				   modifier == NARROW ? ncopies / 2 : ncopies,
-				   mask, &vec_masks);
+				   mask, &vec_masks, masktype);
   for (int j = 0; j < ncopies; ++j)
     {
       tree op, var;

